Subject: bug#4363: 23.1.50; fullscreen (-mode) almost fullscreen

From: Jan Djärv <[email-masked]>
Date: Tue, 22 Sep 2009 19:27:11 +0200

Ulrich Neumerkel skrev:
> Jan Djaerv schrieb:
>> Ulrich Neumerkel skrev:
>>> Windowmanagers still put a titlebar on the fullscreen window.  This can
>>> be avoided by setting the Motif nodecoration hint.  This works in Gnome,
>>> KDE, and many windowmanagers.
>> (set-frame-parameter () 'fullscreen nil)
>>
>> Note that fullscreen is all done by the window manager.  Emacs tells the 
>> window manager to put the window in fullscreen and the window manager does all 
>> the rest.
> 
> Thank you for the hint! I should M-x info, not merely view-emacs-news.
> 
> With fullboth there are no titles under Gnome, fine!  The no mouse's
> land between left screen side and scrollbar is still there which is
> irritating for mouse positioning.  It is exactly as wide as the
> internal border.  With (set-frame-parameter () 'internal-border-width 0)
> this can be removed.  Ideally, would be part of fullboth, such that
> (set-frame-parameter () 'fullscreen nil) restores the original state.
> 
> Also, the remaining white vertical line on the left side of the screen
> could be removed in fullscreen.  For smaller width of the scrollbar
> that line looks quite "noisy" and irritates because it suggests that
> exact positioning is necessary.
> 
> I tried various resolutions, screens and looked at differences in
> scroll-bar-width.  For some, there opens up a space between (left)
> scrollbar and fringe - sometimes this is on the right side
> (perferable): (set-frame-parameter () 'scroll-bar-width 11)

Well, it is dependent on the screen resolution, the font used and the theme 
used for the scroll bar.  Also, border or not is a matter of taste.

> 
> http://www.complang.tuwien.ac.at/ulrich/emacs/pt.png
> 
> Ideally, the left side (that's where one is looking at most of the
> time) looks always the same regardless of screen width.  Having some
> internal border on the right side for padding is less irritating.  (I
> would prefer here to take some pixels off the fringe, all else equal.)
> 
> Another point is the echo area: The space below the echo area is
> currently used for padding in fullscreen.  This looks irritating
> because it suggests that some over long line is present and makes me
> search the entire area, could be lot's of spaces... Like C-x C-e on
> "\n" Maybe padding is better put to the top or both.

This is hard work for little gain.

> 
> For the qvwm windowmanager (preinstalled on IGEL X-terminals) neither
> maximized nor fullboth works.  Yet, other programs are still able to
> go fullscreen under qvwm (like acroread).  What I do there so far with
> Emacs is to set this Motif nodecoration hint.  That removes the
> decoration.  The rest manually with geometries.

Qvwm probably don't support EWMH.  Programs like acroread use override 
redirect to do fullscreen.  I am not willing to do that for Emacs, since if 
anything goes wrong, you are stuck.

> 
> I manually added that ad-hoc for some time - since about 20.7. Here is one
> http://www.complang.tuwien.ac.at/ulrich/emacs-21.2.50.1-motifhint.tgz
> 
>>> Within Gnome, switching with Alt-TAB between windows causes irritating
>>> flicker with an Emacs fullscreen present.
>> Irritating flicker in Emacs or the other windows?  If the other windows, there 
>> is nothing we can do.
> 
> After some experiments with other fullscreen programs: It's very
> probably compiz.real (part of Gnome) - if that is killed, things work
> as expected.  (During Alt-Tab the fullscreen program tries to regain
> the screen)
> 
> 
> 
> Things have really improved a lot!  Why not put a fullscreen-mode on
> f11?
> 

I'm not sure F11 is a common key for fullscreen.  I'll have to investigate 
that first.

I'm closing this bug, as the bug part has been fixed.

	Jan D.